package de.firstdata.ipg.api.client.action.object;

import java.util.Date;
import java.util.Locale;

import org.apache.commons.lang3.time.FastDateFormat;

import de.firstdata.ipg.api.client.action.IPGApiAction;
import de.firstdata.ipg.api.schema.Action;
import de.firstdata.ipg.api.schema.ClientLocale;

public abstract class IPGAPIActionObject extends Action implements IPGApiAction {

	private final static FastDateFormat DATE_FORMATTER = FastDateFormat.getInstance("yyyyMMdd");

	protected static String getFormattedDate(final Date value) {
		return DATE_FORMATTER.format(value);
	}

	@Override
	public void setClientLocale(final Locale value) {
		if (value == null) {
			this.clientLocale = null;
		} else {
			this.clientLocale = new ClientLocale();
			final String country = value.getCountry();
			if (country != null && country.length() > 0) {
				this.clientLocale.setCountry(country);
			}
			this.clientLocale.setLanguage(value.getLanguage());
		}
	}
}
