package de.firstdata.ipg.api.client.transaction.alipay.object;

import java.math.BigDecimal;
import java.net.URI;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.alipay.AlipaySaleTransaction;
import de.firstdata.ipg.api.schema.AlipayDomesticInformation;

public final class AlipaySaleTransactionObject extends AlipayTransactionObject implements AlipaySaleTransaction {

	public AlipaySaleTransactionObject(final Amount amount, final String orderId) {
		super("sale", amount, orderId);
	}

	/** Use for China domestic sale **/
	public AlipaySaleTransactionObject(final Amount amount, final String orderId, final String productCode, final int productQuantity,
			final BigDecimal productPrice, final String productDescription, final URI redirectUrl) {
		this(amount, orderId);
		final AlipayDomesticInformation alipayDomesticInformation = getAlipayDomesticInformation();
		alipayDomesticInformation.setProductCode(productCode);
		alipayDomesticInformation.setProductQuantity(productQuantity);
		alipayDomesticInformation.setProductPrice(productPrice);
		alipayDomesticInformation.setProductDescription(productDescription);
		alipayDomesticInformation.setRedirectUrl(redirectUrl.toString());
	}

	@Override
	public void setPaymentDataType(final String paymentDataType) {
		getAlipayPaymentInformation().setPaymentDataType(paymentDataType);
	}

	@Override
	public void setPaymentData(final String paymentData) {
		getAlipayPaymentInformation().setPaymentData(paymentData);
	}

	@Override
	public void setOrderTitle(final String orderTitle) {
		getAlipayPaymentInformation().setOrderTitle(orderTitle);
	}

	@Override
	public void setOrderDetail(final String orderDetail) {
		getAlipayPaymentInformation().setOrderDetail(orderDetail);
	}
}
