package de.firstdata.ipg.api.client.transaction.customercard.object;

import de.firstdata.ipg.api.client.IPGApiClient;
import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.customercard.CustomerCForceTicketTransaction;
import de.firstdata.ipg.api.client.transaction.customercard.CustomerCard;

/**
 * This class represents a <i>ForceTicket</i> transaction and allows for setting
 * its optional attributes by calling the appropriate <code>setter</code>
 * methods. An instance of this class is created when calling
 * {@link IPGApiClient#createForceTicketTransaction(double, String)}.
 *
 * @author Andreas Schmid
 */
public final class CustomerCForceTicketTransactionObject extends CustomerCTransactionObject implements CustomerCForceTicketTransaction {

	/**
	 * creates a <i>ForceTicket</i> transaction with the minimum set of
	 * parameters - note that you can add optional fields by calling the
	 * appropriate <code>setter</code> methods on the returned
	 * {@link CustomerCForceTicketTransactionObject} instance
	 */
	public CustomerCForceTicketTransactionObject(final Amount amount, final CustomerCard customerCard, final String referenceNumber) {
		super("forceTicket", amount, customerCard, null);
		getTransactionDetails().setReferenceNumber(referenceNumber);
	}
}
