package de.firstdata.ipg.api.client.transaction.dpay.kps.object;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.object.IPGApiTransactionObject;
import de.firstdata.ipg.api.schema.DiversePayTxType;

public abstract class DpayTransactionObject extends IPGApiTransactionObject {

	protected DpayTransactionObject(final Amount amount, final String orderId) {
		super(amount, null, null, orderId);
		getDiversePayTxType().setType(getType());
	}

	@Override
	public void setStoreId(final String storeId) {
		getDiversePayTxType().setStoreId(storeId);
	}

	public void setEntryMode(final String entryMode) {
		getDiversePayTxType().setEntry(entryMode);
	}

	public void setCardNumber(final String value) {
		getDiversePayTxType().setCardNumber(value);
	}

	public void setExpMonth(final String value) {
		getDiversePayTxType().setExpMonth(value);
	}

	public void setExpYear(final String value) {
		getDiversePayTxType().setExpYear(value);
	}

	public void setDescription(final String description) {
		getDiversePayTxType().setProductDescription(description);
	}

	public void setKoreanDetails(final String cardPIN, final String verification) {
		final DiversePayTxType.DiversePayDetails details = new DiversePayTxType.DiversePayDetails();
		details.setPIN(cardPIN);
		details.setVerification(verification);
		getDiversePayTxType().setDiversePayDetails(details);
	}

	@Override
	public DiversePayTxType getDiversePayTxType() {
		if (this.diversePayTxType == null) {
			this.diversePayTxType = new DiversePayTxType();
		}
		return this.diversePayTxType;
	}

	@Override
	public String getStore() {
		return getDiversePayTxType().getStoreId();
	}
}
