package de.firstdata.ipg.api.client.transaction.klarna.object;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.klarna.KlarnaTransaction;
import de.firstdata.ipg.api.client.transaction.object.IPGApiTransactionObject;
import de.firstdata.ipg.api.schema.KlarnaTxType;
import de.firstdata.ipg.api.schema.Transaction;

/**
 * base abstract class for Klarna transaction which implements necessary methods
 * for all transaction types
 *
 * @author f8t3bd0
 */
public abstract class KlarnaTransactionObject extends IPGApiTransactionObject implements KlarnaTransaction {

	protected KlarnaTransactionObject(final String type, final Amount amount, final String orderId, final String tDate) {
		super(amount, null, null, orderId);
		getKlarnaTxType().setType(type);
		getTransactionDetails().setTDate(tDate);
	}

	@Override
	public String getType() {
		return getKlarnaTxType().getType() == null ? null : getKlarnaTxType().getType();
	}

	/**
	 * see {@link Transaction#getKlarnaTxType()}
	 */
	@Override
	public KlarnaTxType getKlarnaTxType() {
		if (this.klarnaTxType == null) {
			this.klarnaTxType = new KlarnaTxType();
		}
		return this.klarnaTxType;
	}

	@Override
	public void setStoreId(final String storeId) {
		getKlarnaTxType().setStoreId(storeId);
	}

	@Override
	public String getStore() {
		return getKlarnaTxType().getStoreId();
	}
}
