package de.firstdata.ipg.api.client.transaction.paypal.object;

import de.firstdata.ipg.api.client.transaction.Amount;
import de.firstdata.ipg.api.client.transaction.object.IPGApiTransactionObject;
import de.firstdata.ipg.api.schema.PayPalTxType;

public abstract class PayPalTransactionObject extends IPGApiTransactionObject {

	protected PayPalTransactionObject(final String type, final Amount amount, final String orderId) {
		super(amount, null, null, orderId);
		getPayPalTxType().setType(type);
	}

	@Override
	public String getType() {
		return getPayPalTxType().getType();
	}

	@Override
	public void setStoreId(final String storeId) {
		getPayPalTxType().setStoreId(storeId);
	}

	@Override
	public PayPalTxType getPayPalTxType() {
		if (this.payPalTxType == null) {
			this.payPalTxType = new PayPalTxType();
		}
		return this.payPalTxType;
	}

	@Override
	public String getStore() {
		return getPayPalTxType().getStoreId();
	}
}
