package de.firstdata.ipg.api.client.transaction.setter;

import javax.xml.datatype.XMLGregorianCalendar;

import de.firstdata.ipg.api.schema.GenderType;

public interface BillingSetter {

	/**
	 * sets the customerID
	 *
	 * @param customerID
	 *            the customerID
	 */
	void setCustomerID(final String customerID);

	/**
	 * sets the customer's name
	 *
	 * @param name
	 *            the customer's name
	 */
	void setName(final String name);

	/**
	 * sets the customer's company
	 *
	 * @param company
	 *            the customer's company
	 */
	void setCompany(final String company);

	/**
	 * sets the first line of the customer's address
	 *
	 * @param address1
	 *            the first line of the customer's address
	 */
	void setAddress1(final String address1);

	/**
	 * sets the second line of the customer's address
	 *
	 * @param address2
	 *            the second line of the customer's address
	 */
	void setAddress2(final String address2);

	/**
	 * sets the customer's city
	 *
	 * @param city
	 *            the customer's city
	 */
	void setCity(final String city);

	/**
	 * sets the customer's state
	 *
	 * @param state
	 *            the customer's state
	 */
	void setState(final String state);

	/**
	 * sets the customer's zip code
	 *
	 * @param zip
	 *            the customer's zip code
	 */
	void setZip(final String zip);

	/**
	 * sets the customer's country
	 *
	 * @param country
	 *            the customer's country
	 */
	void setCountry(final String country);

	/**
	 * sets the customer's phone number
	 *
	 * @param phone
	 *            the customer's phone number
	 */
	void setPhone(final String phone);

	/**
	 * sets the customer's fax number
	 *
	 * @param fax
	 *            the customer's fax number
	 */
	void setFax(final String fax);

	/**
	 * sets the customer's Email address
	 *
	 * @param email
	 *            the customer's Email address
	 */
	void setEmail(final String email);

	/**
	 * @param value
	 *            personal number of the customer
	 */
	void setPersonalNumber(final String personalNumber);

	/**
	 * @param birthDate
	 *            customer birth date
	 */
	void setBirthDate(final XMLGregorianCalendar birthDate);

	/**
	 * @param gender
	 *            customer gender - either {@link GenderType#MALE} or
	 *            {@link GenderType#FEMALE}
	 */
	void setGender(final GenderType gender);

	/**
	 * @param firstname
	 *            customer firstname
	 */
	void setFirstname(final String firstname);

	/**
	 * @param surname
	 *            customer surname
	 */
	void setSurname(final String surname);

	/**
	 * @param streetName
	 *            customer street
	 */
	void setStreetName(final String streetName);

	/**
	 * @param houseNumber
	 *            customer house number
	 */
	void setHouseNumber(final String houseNumber);

	/**
	 * @param houseExtension
	 *            customer house extension
	 */
	void setHouseExtension(final String houseExtension);

	/**
	 * @param mobilePhone
	 *            customer mobile phone
	 */
	void setMobilePhone(final String mobilePhone);

	/**
	 * sets the customer's address number
	 *
	 * @param addressNumber
	 *            the customer's address number
	 */
	@Deprecated
	void setAddressNumber(final String addressNumber);
}
